import { Component, OnInit} from '@angular/core';
import { ServerService } from './services/server.service';
import { FieldBase } from '../app/form/fields/field-base';
import { JsonObjest } from '../app/entities/JsonObject.class';
import { TokenService, TokenProvider } from './services/login/token.service';
import { Router, CanActivate, ActivatedRouteSnapshot, RouterStateSnapshot, ActivatedRoute, NavigationExtras } from '@angular/router';
import { MainSignInComponent } from './login/main-sign-in/main-sign-in.component';
import {BreadcrumbModule,MenuItem} from 'primeng/primeng';
import { BreadcrumbService } from './services/breadcrumb.service';

import { BreadcrumbComponent } from './widgets/breadcrumb/breadcrumb.component';

import { AutocompleteRemoteComponent } from './form/fields/autocomplete-remote/autocomplete-remote.component';


declare var $ :any;
@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  providers:  []
})
export class AppComponent implements OnInit {
  
  fields: any[];

  sliderExpanded : boolean = false;

  
  breadcrumbHome: MenuItem = {icon: 'fa fa-home', routerLink: "/welcome"};
  breadcrumbData: MenuItem[] = new Array<MenuItem>();
  


  constructor(private tokenService : TokenService, private router: Router, private breadcrumbService  : BreadcrumbService, private route: ActivatedRoute) {

  }

  ngOnInit() {

    this.clearbreadCrumb();

    this.breadcrumbService.breadcrumbDataEmitter.subscribe(
      (data) => {
        this.breadcrumbData = data;
      }
    );

    this.breadcrumbService.breadcrumbHomeEmitter.subscribe(
      (data) => {
        this.breadcrumbHome = data;
      }
    );

  }
  


  clearbreadCrumb(){
    this.breadcrumbData.length = 0;
  }


  slideNav(){

    $("#appSidebar").toggleClass("expanded");
    $("#appBody").toggleClass("expanded");

  }



  //loggedInAs : string = null; 

  showLogin : boolean = false;


  login(){
    //redirect to login page
    this.router.navigate(['/login'], { queryParams: { /*refresh : Math.random() ,returnUrl: this.state.url*/ }});
    location.reload();
  }
  
  logout(){
    this.breadcrumbService.clearAll();
    this.tokenService.logout();
    location.reload();
  }


  goToDMPs(){
    this.router.navigate(['/dmps'], { queryParams: { /*refresh : Math.random() ,returnUrl: this.state.url*/ }});
  }

  goToProjects(){
    this.router.navigate(['/projects'], { queryParams: { /*refresh : Math.random() ,returnUrl: this.state.url*/ }});
  }


}

