import { OnInit, Injectable, EventEmitter, Input } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import { MenuItem } from 'primeng/primeng';


@Injectable()
export class BreadcrumbService implements OnInit {


    breadcrumbHomeEmitter: EventEmitter<MenuItem> = new EventEmitter<MenuItem>();
    breadcrumbDataEmitter: EventEmitter<Array<MenuItem>> = new EventEmitter<Array<MenuItem>>();

    @Input() currentHome: MenuItem;
    @Input() currentData: Array<MenuItem>;



    ngOnInit() {
        console.log("Intiated the service")
    }

    setData(breadcrumbData: Array<MenuItem>) {
        this.breadcrumbDataEmitter.emit(breadcrumbData);
    }

    setHome(breadcrumbHome: MenuItem) {
        this.breadcrumbHomeEmitter.emit(breadcrumbHome);
    }

    appendMenuItem(menuItem: MenuItem) {
        //
    }

    clearAll() {
        this.breadcrumbDataEmitter.emit(new Array<MenuItem>());
    }

}