import { Component, Input, OnInit, AfterViewChecked, ViewChild, Injectable } from '@angular/core';

import {RestBase} from './rest-base';


@Injectable()
export class EestoreService implements OnInit {

  base: string = "https://eestore.paas2.uninett.no/api/";

  datarepo: string =  this.base+"datarepo/";
  projectrepo: string =   this.base+"projectrepo/";
  organizationrepo: string = this.base+"organizationrepo/";
  metadataschemarepo: string = this.base+"metadataschemarepo/";
  servicerepo: string = this.base+"servicerepo/";
  personrepo: string = this.base+"personrepo/";
  config: string = this.base+"config/";
  configtags: string = this.base+"configtags/";
  

  constructor(public restBase: RestBase) {
  }

  ngOnInit(){
    
  }


  getDataRepos(){
   return this.restBase.proxy_get(this.datarepo);
  }

  getProjectRepos(){
    return this.restBase.proxy_get(this.projectrepo);
  }

  getOrganizationRepos(){
    return this.restBase.proxy_get(this.organizationrepo);
  }

  getMetadataSchemaRepos(){
    return this.restBase.proxy_get(this.metadataschemarepo);
  }

  getServiceRepos(){
    return this.restBase.proxy_get(this.servicerepo);
  }

  getPersonRepos(){
    return this.restBase.proxy_get(this.personrepo);
  }

  getConfigs(){
    return this.restBase.proxy_get(this.config);
  }

  getConfigTags(){
    return this.restBase.proxy_get(this.configtags);
  }

}